!&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&
    SUBROUTINE PDNEW
!     ******************************************************************
!$$$  SUBPROGRAM DOCUMENTATION BLOCK
!                .      .    .
! SUBPROGRAM:    PDNEW       UPDATE SURFACE PRESSURE
!   PRGRMMR: JANJIC          ORG: W/NP22     DATE: 94-03-08

! ABSTRACT:
!     PDNEW UPDATES THE SURFACE PRESSURE FROM THE TENDENCY
!     COMPUTED IN PDTE.

! PROGRAM HISTORY LOG:
!   87-06-??  JANJIC     - ORIGINATOR
!   95-03-25  BLACK      - CONVERSION FROM 1-D TO 2-D IN HORIZONTAL
!   98-10-30  BLACK      - MODIFIED FOR DISTRIBUTED MEMORY

! USAGE: CALL PDNEW FROM MAIN PROGRAM EBU

!   INPUT ARGUMENT LIST:
!       NONE

!   OUTPUT ARGUMENT LIST:
!     NONE

!   OUTPUT FILES:
!     NONE

!   SUBPROGRAMS CALLED:

!     UNIQUE: NONE

!     LIBRARY: NONE

!   COMMON BLOCKS: CTLBLK
!                  VRBLS
!                  CONTIN

! ATTRIBUTES:
!   LANGUAGE: FORTRAN 90
!   MACHINE : IBM SP
!$$$
!***********************************************************************
!-----------------------------------------------------------------------
    INCLUDE "parmeta.f90"
    INCLUDE "mpp.h"
#include "sp.h"
!-----------------------------------------------------------------------
    LOGICAL :: &
    RUN,FIRST,RESTRT,SIGMA
!----------------------------------------------------------------------
    INCLUDE "COMM_CTLBLK.f90"
!-----------------------------------------------------------------------
    INCLUDE "COMM_VRBLS.f90"
!-----------------------------------------------------------------------
    INCLUDE "COMM_CONTIN.f90"
!-----------------------------------------------------------------------
!--------------UPDATING PRESSURE DIFFERENCE-----------------------------
!-----------------------------------------------------------------------
! MP parallel do
    DO J=MYJS2,MYJE2
        DO I=MYIS,MYIE
            PD(I,J)=PSDT(I,J)*DT+PD(I,J)
        ENDDO
    ENDDO
!-----------------------------------------------------------------------
    RETURN
    END SUBROUTINE PDNEW
