
    SUBROUTINE TPMIX2(P,THES,TU,QU,QLIQ,QICE,QNEWLQ,QNEWIC,RATIO2 &
    , XLV1,XLV0)
!----------------------------------------------------------------------
!*************** LOOKUP TABLE VARIABLES *******************************
    PARAMETER(KFNT=250,KFNP=220)

    COMMON/KFLUT/ TTAB(KFNT,KFNP),QSTAB(KFNT,KFNP),THE0K(KFNP) &
    , ALU(200),RDPR,RDTHK,PTOP
!***************************************************************

!***********************************************************************
!*** SCALING PRESSURE & TT TABLE INDEX
!***********************************************************************

    TP=(P-PTOP)*RDPR
    QQ=TP-AINT(TP)
    IPTB=INT(TP)+1

!***********************************************************************
!*** BASE AND SCALING FACTOR FOR THE
!***********************************************************************

!*** SCALING THE & TT TABLE INDEX

    BTH=(THE0K(IPTB+1)-THE0K(IPTB))*QQ+THE0K(IPTB)
    TTH=(THES-BTH)*RDTHK
    PP =TTH-AINT(TTH)
    ITHTB=INT(TTH)+1

    T00=TTAB(ITHTB ,IPTB )
    T10=TTAB(ITHTB+1,IPTB )
    T01=TTAB(ITHTB ,IPTB+1)
    T11=TTAB(ITHTB+1,IPTB+1)

    Q00=QSTAB(ITHTB ,IPTB )
    Q10=QSTAB(ITHTB+1,IPTB )
    Q01=QSTAB(ITHTB ,IPTB+1)
    Q11=QSTAB(ITHTB+1,IPTB+1)

!***********************************************************************
!*** PARCEL TEMPERATURE
!***********************************************************************

    TEMP=(T00+(T10-T00)*PP+(T01-T00)*QQ &
    +(T00-T10-T01+T11)*PP*QQ)

    QS=(Q00+(Q10-Q00)*PP+(Q01-Q00)*QQ &
    +(Q00-Q10-Q01+Q11)*PP*QQ)

    DQ=QS-QU
    IF(DQ <= 0.)THEN
        QNEW=QU-QS
        QU=QS
    ELSE
    
    !   IF THE PARCEL IS SUBSATURATED, TEMPERATURE AND MIXING RATIO MUST BE
    !   ADJUSTED...IF LIQUID WATER IS PRESENT, IT IS ALLOWED TO EVAPORATE
    
        QNEW=0.
        QTOT=QLIQ+QICE
    
    !   IF THERE IS ENOUGH LIQUID OR ICE TO SATURATE THE PARCEL, TEMP STAYS AT ITS
    !   WET BULB VALUE, VAPOR MIXING RATIO IS AT SATURATED LEVEL, AND THE MIXING
    !   RATIOS OF LIQUID AND ICE ARE ADJUSTED TO MAKE UP THE ORIGINAL SATURATION
    !   DEFICIT... OTHERWISE, ANY AVAILABLE LIQ OR ICE VAPORIZES AND APPROPRIATE
    !   ADJUSTMENTS TO PARCEL TEMP; VAPOR, LIQUID, AND ICE MIXING RATIOS ARE MADE.
    
    !...subsaturated values only occur in calculations involving various mixtures of
    !...updraft and environmental air for estimation of entrainment and detrainment.
    !...For these purposes, assume that reasonable estimates can be given using
    !...liquid water saturation calculations only - i.e., ignore the effect of the
    !...ice phase in this process only...will not affect conservative properties...
    
        IF(QTOT >= DQ)THEN
            qliq=qliq-dq*qliq/(qtot+1.e-10)
            qice=qice-dq*qice/(qtot+1.e-10)
            QU=QS
        ELSE
            RLL=XLV0-XLV1*TEMP
            CPP=1005.7*(1.+0.89*QU)
            IF(QTOT < 1.E-10)THEN
            
            !...IF NO LIQUID WATER OR ICE IS AVAILABLE, TEMPERATURE IS GIVEN BY:
                TEMP=TEMP+RLL*(DQ/(1.+DQ))/CPP
            ELSE
            
            !...IF SOME LIQ WATER/ICE IS AVAILABLE, BUT NOT ENOUGH TO ACHIEVE SATURATION,
            !   THE TEMPERATURE IS GIVEN BY:
            
                TEMP=TEMP+RLL*((DQ-QTOT)/(1+DQ-QTOT))/CPP
                QU=QU+QTOT
                QTOT=0.
                QLIQ=0.
                QICE=0.
            ENDIF
        ENDIF
    ENDIF
    TU=TEMP
    qnewlq=qnew
    qnewic=0.

    RETURN
    END SUBROUTINE TPMIX2

