!&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&
    SUBROUTINE ZERO3_T(ARRAY,LL)
!     ******************************************************************
!$$$  SUBPROGRAM DOCUMENTATION BLOCK
!                .      .    .
! SUBPROGRAM:    ZERO3_T     ZERO OUT TRANSPOSED 3-D ARRAYS
!   PRGRMMR: BLACK           ORG: W/NP2      DATE: 99-07-06

! ABSTRACT:
!     SET THE VALUES OF THE ARTIFICIAL EXTERNAL (OUT-OF-BOUNDS) EDGES
!     TO ZERO

! PROGRAM HISTORY LOG:
!   99-07-06  BLACK      - ORIGINATOR

! USAGE: CALL ZERO3_T FROM ANY ROUTINE NEEDING THIS PROCEDURE
!   INPUT ARGUMENT LIST:
!       THE DUMMY ARRAY NAME

!   OUTPUT ARGUMENT LIST:
!     THE DUMMY ARRAY NAME

!   OUTPUT FILES:
!     NONE

!   SUBPROGRAMS CALLED:

!     UNIQUE: NONE

!     LIBRARY: NONE

! ATTRIBUTES:
!   LANGUAGE: FORTRAN 90
!   MACHINE : IBM SP
!$$$
!***********************************************************************
!-----------------------------------------------------------------------
    INCLUDE "parmeta.f90"
    INCLUDE "mpp.h"
#include "sp.h"
!-----------------------------------------------------------------------
    DIMENSION &
    ARRAY(LL,IDIM1:IDIM2,JDIM1:JDIM2)
!-----------------------------------------------------------------------
!-----------------------------------------------------------------------
    DO J=JDIM1,JDIM2
        DO I=IDIM1,IDIM2
            DO L=1,LL
                ARRAY(L,I,J)=0.
            ENDDO
        ENDDO
    ENDDO
!----------------------------------------------------------------
!----------------------------------------------------------------
    RETURN
    END SUBROUTINE ZERO3_T
