 module rdparm

 implicit none 

!     PARAMETER SETTINGS FOR THE LONGWAVE AND SHORTWAVE RADIATION CODE:
!          IMAX   =  NO. POINTS ALONG THE LAT. CIRCLE USED IN CALCS.
!          L      =  NO. VERTICAL LEVELS (ALSO LAYERS) IN MODEL
!***NOTE: THE USER NORMALLY WILL MODIFY ONLY THE IMAX AND L PARAMETERS
!          NBLW   =  NO. FREQ. BANDS FOR APPROX COMPUTATIONS. SEE
!                      BANDTA FOR DEFINITION
!          NBLX   =  NO. FREQ BANDS FOR APPROX CTS COMPUTATIONS
!          NBLY   =  NO. FREQ. BANDS FOR EXACT CTS COMPUTATIONS. SEE
!                      BDCOMB FOR DEFINITION
!          INLTE  =  NO. LEVELS USED FOR NLTE CALCS.
!          NNLTE  =  INDEX NO. OF FREQ. BAND IN NLTE CALCS.
!          NB,KO2 ARE SHORTWAVE PARAMETERS; OTHER QUANTITIES ARE DERIVED
!                    FROM THE ABOVE PARAMETERS.
INTEGER,PARAMETER:: L=LM
INTEGER,PARAMETER:: IMAX=IM
INTEGER,PARAMETER:: NBLW=163,NBLX=47,NBLY=15
INTEGER,PARAMETER:: NBLM=NBLY-1
INTEGER,PARAMETER:: LP1=L+1,LP2=L+2,LP3=L+3
INTEGER,PARAMETER:: LM1=L-1,LM2=L-2,LM3=L-3
INTEGER,PARAMETER:: LL=2*L,LLP1=LL+1,LLP2=LL+2,LLP3=LL+3
INTEGER,PARAMETER:: LLM1=LL-1,LLM2=LL-2,LLM3=LL-3
INTEGER,PARAMETER:: LP1M=LP1*LP1,LP1M1=LP1M-1
INTEGER,PARAMETER:: LP1V=LP1*(1+2*L/2)
INTEGER,PARAMETER:: LP121=LP1*NBLY
INTEGER,PARAMETER:: LL3P=3*L+2
INTEGER,PARAMETER:: NB=12
INTEGER,PARAMETER:: INLTE=3,INLTEP=INLTE+1,NNLTE=56
INTEGER,PARAMETER:: LP1I=IMAX*LP1,LLP1I=IMAX*LLP1,LL3PI=IMAX*LL3P
INTEGER,PARAMETER:: NB1=NB-1
INTEGER,PARAMETER:: KO2=12
INTEGER,PARAMETER:: KO21=KO2+1,KO2M=KO2-1

end module 
